import java.lang.Math;
import java.util.*;
import java.awt.*;
import java.applet.*;

public class CoCchar extends Applet {
	Random rnd;
	TextArea ta;
	Button b_generate;
	String s_generate = "Create New Investigator";
	Button b_school;
	String s_school = "Extended Schooling: 1 year";
	Button b_age;
	String s_age = "Age Investigator: 10 years";
	CheckboxGroup cg_era;
	Checkbox c1890, c1920, c1990;
	CheckboxGroup cg_age;
	Checkbox cSTR, cCON, cDEX, cAPP, c_age;
	static int rows = 24;
	static int cols = 80;
	int era = 1920;
	int strength;
	int dexterity;
	int intelligence;
	int constitution;
	int appearance;
	int power;
	int size;
	int sanity;
	int education;
	int idea;
	int luck;
	int know;
	String dmgBonus;
	int hp;
	int occupation;
	int interest;
	int minAge = 0;
	int age = 0;
	int wealth;
	int income;
	int dodge;

	int d(int x) {
		double f = rnd.nextDouble();
		f *= (double) x;
		int i = (int) f;
		return 1+i;
	}

	String rpad(String s, int n) {
		while (s.length() < n) {
			s = " "+s;
		}
		return s;
	}

	String rpad(int d, int n) {
		String s = String.valueOf(d);
		while (s.length() < n) {
			s = " "+s;
		}
		return s;
	}

	String damageBonus(int strsiz) {
		// range limited to initial human statistics
		if (strsiz < 13) return "-1D6";
		if (strsiz < 17) return "-1D4";
		if (strsiz < 25) return "none";
		if (strsiz < 33) return "+1D4";
		return "+1D6";
	}

	String damageBonus(int str, int siz) {
		return damageBonus(str+siz);
	}

	int calcIncome(int wealth) {
		int income;

		if (era == 1890) {
			income = wealth*5000;
		} else if (era == 1920) {
			income = wealth*1000+3500;
		} else {
			income = wealth*10000+5000;
		}
		return income;
	}

	void derive() {
		// derived stats that may vary
		dmgBonus = damageBonus(strength,size);
		hp = (int) ((constitution+size+1)/2);
		dodge = 2*dexterity;
		know = 5*education;
		if (know > 99) know = 99;
	}

	void generate() {
		strength = d(6)+d(6)+d(6);
		dexterity = d(6)+d(6)+d(6);
		intelligence = 6+d(6)+d(6);
		constitution = d(6)+d(6)+d(6);
		appearance = d(6)+d(6)+d(6);
		power = d(6)+d(6)+d(6);
		size = 6+d(6)+d(6);
		sanity = 5*power;
		education = 3+d(6)+d(6)+d(6);
		idea = 5*intelligence;
		luck = 5*power;
		occupation = 20*education;
		interest = 10*intelligence;
		derive();
		minAge = 6+education;
		age = minAge;
		wealth = d(10);
		income = calcIncome(wealth);

		ta.setText("STR: "+rpad(strength,2)+"    DEX: "
			+rpad(dexterity,2)+"    INT: "+rpad(intelligence,2)
			+"    Idea Roll: "+rpad(idea,3)+"%\n");
		ta.appendText("CON: "+rpad(constitution,2)+"    APP: "
			+rpad(appearance,2)+"    POW: "+rpad(power,2)
			+"    Luck Roll: "+rpad(luck,3)+"%\n");
		ta.appendText("SIZ: "+rpad(size,2)+"    SAN: "+rpad(sanity,2)
			+"    EDU: "+rpad(education,2)+"    Know Roll: "
			+rpad(know,3)+"%\n");
		ta.appendText("Damage Bonus: "+dmgBonus+"    Hit Points: "
			+rpad(hp,2)+"\n");
		ta.appendText("Occupation Points: "+rpad(occupation,3)
			+"    Personal Interest Points: "+rpad(interest,3)
			+"\n");
		ta.appendText("Minimum Age: "+minAge+"    Base Dodge skill: "
			+rpad(dodge,2)+"%\n");
		ta.appendText(era+"s Income: $"+income+"\n");
	}

	void school() {
		int old = know;
		age++;
		ta.appendText(" Your age is now "+age+".");
		if (d(100) <= know) {
			education++;
			derive();
			ta.appendText("  Your EDU is now "+education+".");
			if (know != old) ta.appendText("  Your Know roll is "
				+know+"%");
		}
		interest += 10;
		ta.appendText("\n  Your personal interest points are now "
			+interest+".\n");
	}

	void age10() {
		int oldKnow = know;
		age += 10;
		ta.appendText(" Your age is now "+age+". ");
		education++;
		derive();
		ta.appendText(" Your EDU is now "+education+".");
		if (know != oldKnow) ta.appendText("  Your Know roll is "
			+know+"%");
		occupation += 20;
		ta.appendText("\n  Your occupation points are now "
			+occupation+".\n");
		if (age > 40) {
			if (c_age == cSTR) {
				String old = dmgBonus;
				strength--;
				ta.appendText("  Your STR is now "
					+strength+".");
				derive();
				if (! old.equals(dmgBonus))
					ta.appendText("  Your damage bonus is now "+dmgBonus+".");
			} else if (c_age == cCON) {
				int old = hp;
				constitution--;
				ta.appendText("  Your CON is now "
					+constitution+".");
				derive();
				if (old != hp)
					ta.appendText("  Your hit points are now "+hp+".");
			} else if (c_age == cDEX) {
				dexterity--;
				derive();
				ta.appendText("  Your DEX is now "
					+dexterity
					+".  Your base Dodge skill is now "
					+dodge+"%.");
			} else if (c_age == cAPP) {
				appearance--;
				ta.appendText("  Your APP is now "
					+appearance+".");
			}
			ta.appendText("\n");
		}
	}

	public void init() {
		rnd = new Random();
//	 setLayout(new BorderLayout());
		Panel p = new Panel();
		p.add(ta = new TextArea(rows,cols));
		add("North",p);
		ta.setFont(new Font("Courier",Font.PLAIN,12));
		ta.setEditable(false);
		ta.setText("Minimal Call of Cthulhu Character Generation\n\n"
			+"For \"Call of Cthulhu\", 5th edition, Copyright (C) 1992 by Chaosium Inc.,\nall rights reserved.\n\n"
			+"This program written by Jim W. Lai; additional Copyright (C) 1997.\n\n"
			+"Call of Cthulhu is a registered trademark of Chaosium, Inc.");
		p = new Panel();
		p.add(new Label("Investigator Era:"));
		cg_era = new CheckboxGroup();
		p.add(c1890 = new Checkbox("1890s",cg_era,false));
		p.add(c1920 = new Checkbox("1920s",cg_era,true));
		p.add(c1990 = new Checkbox("1990s",cg_era,false));
		p.add(b_generate = new Button(s_generate));
		add("Center",p);
		p = new Panel();
		p.add(b_school = new Button(s_school));
		b_school.disable();
		add("Center",p);
		p = new Panel();
		p.add(new Label("Preferred Aging Loss:"));
		cg_age = new CheckboxGroup();
		p.add(cSTR = new Checkbox("STR",cg_age,true));
		cSTR.disable();
		c_age = cSTR;
		p.add(cCON = new Checkbox("CON",cg_age,false));
		cCON.disable();
		p.add(cDEX = new Checkbox("DEX",cg_age,false));
		cDEX.disable();
		p.add(cAPP = new Checkbox("APP",cg_age,false));
		cAPP.disable();
		p.add(b_age = new Button(s_age));
		b_age.disable();
		add("South",p);
		resize(preferredSize());
	}

	public boolean handleEvent(Event e) {
		if (e.id == Event.WINDOW_DESTROY) System.exit(0);
		return super.handleEvent(e);
	}

	public boolean action(Event e, Object o) {
		if (e.target.equals(b_generate) && o.equals(s_generate)) {
			cSTR.disable();
			cCON.disable();
			cDEX.disable();
			cAPP.disable();
			generate();
			b_school.enable();
			b_age.enable();
			return true;
		}
		if (e.target.equals(b_school) && o.equals(s_school)) {
			b_school.disable();
			school();
			return true;
		}
		if (e.target.equals(b_age) && o.equals(s_age)) {
			boolean enable = true;
			b_age.disable();
			age10();
			if (age > 40) {
				if (strength < 2) {
					cSTR.disable();
					if (c_age == cSTR) enable = false;
				}
				if (constitution < 2) {
					cCON.disable();
					if (c_age == cCON) enable = false;
				}
				if (dexterity < 2) {
					cDEX.disable();
					if (c_age == cDEX) enable = false;
				}
				if (appearance < 2) {
					cAPP.disable();
					if (c_age == cAPP) enable = false;
				}
			} else if (age > 30) {
				cSTR.enable();
				cCON.enable();
				cDEX.enable();
				cAPP.enable();
			}
			if (enable) b_age.enable();
			return true;
		}
		if (e.target.equals(cSTR)) {
			c_age = cSTR;
			b_age.enable();
			return true;
		}
		if (e.target.equals(cCON)) {
			c_age = cCON;
			b_age.enable();
			return true;
		}
		if (e.target.equals(cDEX)) {
			c_age = cDEX;
			b_age.enable();
			return true;
		}
		if (e.target.equals(cAPP)) {
			c_age = cAPP;
			b_age.enable();
			return true;
		}
		if (e.target.equals(c1890)) {
			era = 1890;
			return true;
		}
		if (e.target.equals(c1920)) {
			era = 1920;
			return true;
		}
		if (e.target.equals(c1990)) {
			era = 1990;
			return true;
		}
		return super.action(e, o);
	}
}
